From 056f3303fb3e1257ea6d8141bb7aaf6b3ebb8c67 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 10 2020 07:16:33 +0000
Subject: [PATCH 1682/2232] Merge pull request #557 from dtolnay/sizet


Include <cstddef> everywhere that size_t makes an appearance
---

diff --git a/gen/src/builtin.rs b/gen/src/builtin.rs
index 837761d..62c3527 100644
--- a/gen/src/builtin.rs
+++ b/gen/src/builtin.rs
@@ -161,6 +161,7 @@ pub(super) fn write(out: &mut OutFile) {
     out.begin_block(Block::AnonymousNamespace);
 
     if builtin.ptr_len {
+        include.cstddef = true;
         out.begin_block(Block::Namespace("repr"));
         writeln!(out, "struct PtrLen final {{");
         writeln!(out, "  void *ptr;");
@@ -241,6 +242,7 @@ pub(super) fn write(out: &mut OutFile) {
     }
 
     if builtin.is_complete {
+        include.cstddef = true;
         include.type_traits = true;
         out.next_section();
         writeln!(out, "template <typename T, typename = size_t>");
@@ -296,6 +298,7 @@ pub(super) fn write(out: &mut OutFile) {
     out.end_block(Block::Namespace("rust"));
 
     if builtin.exception {
+        include.cstddef = true;
         out.begin_block(Block::ExternC);
         writeln!(
             out,
diff --git a/gen/src/write.rs b/gen/src/write.rs
index e29d5f6..03ebeb5 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -158,6 +158,7 @@ fn write_std_specializations(out: &mut OutFile, apis: &[Api]) {
         if let Api::Struct(strct) = api {
             if derive::contains(&strct.derives, Trait::Hash) {
                 out.next_section();
+                out.include.cstddef = true;
                 out.include.functional = true;
                 let qualified = strct.name.to_fully_qualified();
                 writeln!(out, "template <> struct hash<{}> {{", qualified);
@@ -467,6 +468,7 @@ fn write_struct_operator_decls<'a>(out: &mut OutFile<'a>, strct: &'a Struct) {
     }
 
     if derive::contains(&strct.derives, Trait::Hash) {
+        out.include.cstddef = true;
         let link_name = mangle::operator(&strct.name, "hash");
         writeln!(
             out,
@@ -1360,6 +1362,8 @@ fn write_rust_vec_extern(out: &mut OutFile, element: &RustName) {
     let inner = element.to_typename(out.types);
     let instance = element.to_mangled(out.types);
 
+    out.include.cstddef = true;
+
     writeln!(out, "#ifndef CXXBRIDGE1_RUST_VEC_{}", instance);
     writeln!(out, "#define CXXBRIDGE1_RUST_VEC_{}", instance);
     writeln!(
@@ -1419,6 +1423,8 @@ fn write_rust_vec_impl(out: &mut OutFile, element: &RustName) {
     let inner = element.to_typename(out.types);
     let instance = element.to_mangled(out.types);
 
+    out.include.cstddef = true;
+
     writeln!(out, "template <>");
     writeln!(out, "Vec<{}>::Vec() noexcept {{", inner);
     writeln!(out, "  cxxbridge1$rust_vec${}$new(this);", instance);
@@ -1671,6 +1677,8 @@ fn write_cxx_vector(out: &mut OutFile, element: &RustName) {
     let inner = element.to_typename(out.types);
     let instance = element.to_mangled(out.types);
 
+    out.include.cstddef = true;
+
     writeln!(out, "#ifndef CXXBRIDGE1_VECTOR_{}", instance);
     writeln!(out, "#define CXXBRIDGE1_VECTOR_{}", instance);
     writeln!(

